import copy from 'fast-copy';
import { freezeSys, toPlainObject } from 'contentful-sdk-core';
/**
 * @private
 * @param makeRequest - function to make requests via an adapter
 * @param data - Raw app access token data
 * @return {AppAccessToken} Wrapped AppAccessToken data
 */
export function wrapAppAccessToken(_makeRequest, data) {
  const appAccessToken = toPlainObject(copy(data));
  return freezeSys(appAccessToken);
}